"""adding STAC api components

Revision ID: 8459fe5b8174
Revises: e347f9f15c4f
Create Date: 2020-07-14 23:54:20.655051

"""
from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision = '8459fe5b8174'
down_revision = 'e347f9f15c4f'
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table('api_keys',
    sa.Column('api_key', sa.String(), nullable=False),
    sa.Column('permissions', sa.String(), nullable=True),
    sa.PrimaryKeyConstraint('api_key')
    )
    op.create_table('attribute_table',
    sa.Column('asset_id', sa.String(), nullable=False),
    sa.Column('catalog', sa.String(), nullable=False),
    sa.Column('key', sa.String(), nullable=False),
    sa.Column('value', sa.String(), nullable=True),
    sa.PrimaryKeyConstraint('asset_id', 'catalog', 'key')
    )
    op.create_table('catalog_table',
    sa.Column('asset_id', sa.String(), nullable=False),
    sa.Column('catalog', sa.String(), nullable=False),
    sa.Column('bb_xmin', sa.Float(), nullable=False),
    sa.Column('bb_xmax', sa.Float(), nullable=False),
    sa.Column('bb_ymin', sa.Float(), nullable=False),
    sa.Column('bb_ymax', sa.Float(), nullable=False),
    sa.Column('utc_datetime', sa.String(), nullable=False),
    sa.Column('expiration_utc_datetime', sa.String(), nullable=True),
    sa.Column('mediatype', sa.String(), nullable=False),
    sa.Column('description', sa.String(), nullable=False),
    sa.Column('uri', sa.String(), nullable=False),
    sa.Column('local_path', sa.String(), nullable=False),
    sa.Column('raster_min', sa.Float(), nullable=False),
    sa.Column('raster_max', sa.Float(), nullable=False),
    sa.Column('raster_mean', sa.Float(), nullable=False),
    sa.Column('raster_stdev', sa.Float(), nullable=False),
    sa.Column('default_style', sa.String(), nullable=False),
    sa.PrimaryKeyConstraint('asset_id', 'catalog')
    )
    op.create_index(op.f('ix_catalog_table_bb_xmax'), 'catalog_table', ['bb_xmax'], unique=False)
    op.create_index(op.f('ix_catalog_table_bb_xmin'), 'catalog_table', ['bb_xmin'], unique=False)
    op.create_index(op.f('ix_catalog_table_bb_ymax'), 'catalog_table', ['bb_ymax'], unique=False)
    op.create_index(op.f('ix_catalog_table_bb_ymin'), 'catalog_table', ['bb_ymin'], unique=False)
    op.create_index(op.f('ix_catalog_table_mediatype'), 'catalog_table', ['mediatype'], unique=False)
    op.create_index(op.f('ix_catalog_table_utc_datetime'), 'catalog_table', ['utc_datetime'], unique=False)
    op.create_table('global_variables',
    sa.Column('key', sa.String(), nullable=False),
    sa.Column('value', sa.LargeBinary(), nullable=True),
    sa.PrimaryKeyConstraint('key')
    )
    op.create_table('job_table',
    sa.Column('job_id', sa.String(), nullable=False),
    sa.Column('data_uri', sa.String(), nullable=False),
    sa.Column('job_status', sa.String(), nullable=False),
    sa.PrimaryKeyConstraint('job_id')
    )
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_table('job_table')
    op.drop_table('global_variables')
    op.drop_index(op.f('ix_catalog_table_utc_datetime'), table_name='catalog_table')
    op.drop_index(op.f('ix_catalog_table_mediatype'), table_name='catalog_table')
    op.drop_index(op.f('ix_catalog_table_bb_ymin'), table_name='catalog_table')
    op.drop_index(op.f('ix_catalog_table_bb_ymax'), table_name='catalog_table')
    op.drop_index(op.f('ix_catalog_table_bb_xmin'), table_name='catalog_table')
    op.drop_index(op.f('ix_catalog_table_bb_xmax'), table_name='catalog_table')
    op.drop_table('catalog_table')
    op.drop_table('attribute_table')
    op.drop_table('api_keys')
    # ### end Alembic commands ###
